# 编排配置说明文档


## 功能菜单
WeCube界面导航包含任务、设计、执行、监测、调整、智慧、协同、系统共八个主菜单。

访问 “协同 > 任务编排” 菜单
![orchestration_menu](images/orchestration_menu.png)

进入 “任务编排管理” 页面
![orchestration_main](images/orchestration_main.png)

点击 “编排名称” 下拉选择框， 可以新增编排或者查看已经配置好的编排列表
![orchestration_search](images/orchestration_search.png)

在编排下拉列表选中一个已经编排, 显示编排详细信息
![orchestration_search_result](images/orchestration_search_result.png)


## 编排元素
在编排编辑页面中，除了显示当前选择编排节点和流程信息外， 还显示了编排可以用使用的节点元素，见下图红框部分
![orchestration_config_item](images/orchestration_config_item.png)

自上而下编排元素依次为：
	- 启动手动工具
	- 启动Lasso工具
	- 启动创建/删除空间工具
	- 启动全局连接工具
	- 创建StratEvent
	- Create intermediate/Boundary Event
	- 创建EndEvent
	- Create Gateway
	- 创建Task
	- 创建可折叠子流程

各元素详细说明是使用方式详见文档[camunda产品模型官网](https://camunda.com/products/modeler/)

## 新增编排
下面以 “删除MYSQL” 为例， 演示如何新增一个编排。

1. 新建编排

点击 “编排名称” 下拉框右侧的加号按钮， 开始新建编排，弹出新建编排的权限配置页面，如下图所示：
![orchestration_new_auth_1](images/orchestration_new_auth_1.png)

页面上半部分的 “属主角色” 决定哪些角色的用户可以编辑、查看和使用该编排。角色清单是当前用户所拥有的角色。

页面下半部分的 “使用角色” 决定哪些角色的用户可以查看和使用该编排， 但是无编排的编辑权限。

配置完成后， 点击 “确定” 保存，权限配置页面关闭
![orchestration_new_auth_2](images/orchestration_new_auth_2.png)

2. 编排编辑页面

权限配置页面关闭后， 回到编排编辑页面
![orchestration_new_step_1](images/orchestration_new_step_1.png)

3. 选择编排实体类型

在 “编排实体类型” 下拉框中选择编排关联的实体类型， 实体类型来源于各插件提供的数据模型。
![orchestration_new_step_2](images/orchestration_new_step_2.png)
本示例所演示的“删除MYSQL” 属于wecmdb的 “resource_instance” 资源实例类型。

4. 编排名称和版本

在编排编辑页面右侧， 输入编排名称和版本名称，如下图：
![orchestration_new_step_3](images/orchestration_new_step_3.png)

5. 配置编排流程节点
	- 在编排元素面板中，点击选中 “创建StratEvent”， 拖到画布空白处，如下图， 在开始节点右侧的小图标中选择 “追加Task”
![orchestration_new_step_4](images/orchestration_new_step_4.png)

	- 新增一个任务节点， 在右侧 “名称”输入框中输入节点名称，点击工具按钮，修改节点类型，当前Task类型只支持“可折叠子流程”。
![orchestration_new_step_4_1](images/orchestration_new_step_4_1.png)

	- 右键选择 “配置插件”
![orchestration_new_step_5](images/orchestration_new_step_5.png)

	- 在弹出页面中的 “插件” 下拉框中选择已注册的插件功能
![orchestration_new_step_6](images/orchestration_new_step_6.png)

	- “确认” 保存
![orchestration_new_step_7](images/orchestration_new_step_7.png)

	- 回到主编辑页面， 点击当前节点， 可以继续 “追加Task”
![orchestration_new_step_8](images/orchestration_new_step_8.png)

	- 按同样的方式增加后续节点知道所有流程节点配置完成。注意插件节点中， 如果要使用前置节点的输出作为入参， 可以在插件配置中进行参数配置， 如下图
![orchestration_new_step_9](images/orchestration_new_step_9.png)

	- 流程节点配置完成后， 最后新增一个结束节点 “创建EndEvent”
![orchestration_new_step_10](images/orchestration_new_step_10.png)

	- 点击 “保存编排”
![orchestration_new_step_11](images/orchestration_new_step_11.png)

至此，已经新建了一个完整的编排。能在 “编排名称” 下拉列表中看到刚刚创建的编排， 排在第一位。
![orchestration_new_step_12](images/orchestration_new_step_12.png)


## 修改/删除编排
1. 删除编排

在 “编排名称” 下拉列表中，点击删除按钮， 确认后可以删除编排。
![orchestration_del_1](images/orchestration_del_1.png)

2. 修改编排权限信息

在 “编排名称” 下拉列表中，点击编辑按钮
![orchestration_upd_1](images/orchestration_upd_1.png)

弹出权限修改页面
![orchestration_upd_2](images/orchestration_upd_2.png)
可以修改属主和使用权限。

3. 修改编排的详细信息

在 “编排名称” 下拉列表中， 选择编排，
![orchestration_upd_3](images/orchestration_upd_3.png)

显示编排详细信息，可以进行编辑。
![orchestration_upd_4](images/orchestration_upd_4.png)

注意：当前版本修改编排后需要同时修改编排名称， 否则会保存名称冲突无法保存。

## 编排导出
选择一个编排， 点击 “导出” 按钮，即可完成编排导出。
![orchestration_export](images/orchestration_export.png)


## 编排导入
在任务编排主页面，点击 “导入” 按钮， 在弹出框中选择要导入的编排文件， 点击 “打开”
![orchestration_import_1](images/orchestration_import_1.png)

即可完成编排导入，如下图
![orchestration_import_2](images/orchestration_import_2.png)


